import pygame
from pygame.locals import *
import sys, random
from world import *
from game_entities import *

pygame.init()
screen = pygame.display.set_mode(SCREEN_SIZE, 0, 32)

world = World()

w, h = SCREEN_SIZE
clock = pygame.time.Clock()

ant_image = pygame.image.load("ant.png").convert_alpha()
leaf_image = pygame.image.load("leaf.png").convert_alpha()

for ant_no in xrange(ANT_COUNT):
    ant = Ant(world, ant_image, (random.randint(0,w), random.randint(0, h)))
    ant.brain.set_state("exploring")
    world.add_entity(ant)

while True:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit()

    time_passed = clock.tick(30)

    if random.randint(1, 20) == 1:
        location = (random.randint(0,w), random.randint(0, h))
        leaf = Leaf(world, leaf_image, location)
        world.add_entity(leaf)

    world.process(time_passed)
    world.render(screen)

    pygame.display.update()
